#include <stdio.h>
#include <string.h>

#include "mag_level2_data_1sec.h"
#include "df.h"
#include "mfhdf.h"

int main(argc, argv)
int argc;
char *argv[];
{
  int32 hdf_fp, sd_id;
  struct MAG_data_1sec *testdata;
  int ii,jj,retval;
  int32 numrec;

  if (argc!=2)
    {
      printf("Usage: mag_l2_1sec_rd hdf_file\n");
      exit(1);
    }

  testdata=malloc(sizeof(struct MAG_data_1sec));

  /* open hdf input file */

  if ((hdf_fp=Hopen(argv[1], DFACC_RDONLY, 0))==FAIL) {
      fprintf(stderr, "Hopen: could not open hdf file\n");
      exit(-1);
    }
  Vstart(hdf_fp);

  if ((sd_id=SDstart(argv[1], DFACC_RDONLY))==FAIL) {
	  fprintf(stderr, "SDstart: could not open hdf file\n");
	  exit(-1);
	}

  numrec=init_rd_mag_level2_data_1sec(hdf_fp, sd_id, "r");

  if( numrec<=0) {
    fprintf(stderr,"No mag level2 1sec data\n");
    exit(-1);
  }

  ii=0;
  while((retval= read_mag_level2_data_1sec(testdata, ii))!=-1) {
	  printf("%d %.1f %4d %3d %2d %2d %5.2f ",
		 testdata->SCclock, testdata->ACEepoch, testdata->year, testdata->day, testdata->hr, testdata->min, testdata->sec);
	  printf("%10.4f %10.4f %10.4f ", 
		 testdata->Br, testdata->Bt, testdata->Bn);
	  printf("%10.4f %10.4f %10.4f  %d\n", 
		 testdata->Bgsm_x, testdata->Bgsm_y, testdata->Bgsm_z, testdata->Quality);
	  ii++;
  }

  /* all done, close HDF file */

  close_rd_mag_level2_data_1sec();
  Vend(hdf_fp);
  if (SDend(sd_id)==FAIL) {
      fprintf(stderr, "SDend: could not close hdf file\n");
      exit(-1);
    }
  if (Hclose(hdf_fp)==FAIL) {
      fprintf(stderr, "Hclose: could not close hdf file\n");
      exit(-1);
    }

  exit(0);
}


